"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Server_1 = __importDefault(require("./Server"));
var ProgrammableHTTPSwitchAccessory_1 = __importDefault(require("./ProgrammableHTTPSwitchAccessory"));
var ProgrammableHTTPSwitch = /** @class */ (function () {
    function ProgrammableHTTPSwitch(log, config, api) {
        var _this = this;
        this.accessories = function (callback) {
            var accessories = {};
            for (var _i = 0, _a = _this.config.accessories; _i < _a.length; _i++) {
                var accessory = _a[_i];
                accessories[accessory.identifier] = new ProgrammableHTTPSwitchAccessory_1.default(_this.log, accessory, _this.hap);
            }
            _this.server.setAccessories(accessories);
            _this.server.start();
            callback(Object.values(accessories));
        };
        this.config = config;
        this.log = log;
        this.hap = api.hap;
        this.server = new Server_1.default(this.log, this.config);
        this.log.info('Successfully initialized ProgrammableHTTPSwitch');
    }
    return ProgrammableHTTPSwitch;
}());
exports.default = ProgrammableHTTPSwitch;
